* S*Basic procedure MATFILL
* pjwitte 2oo2 June 2nd 2003
*
* Based on Mattool pjwitte 1991, 1993, 1994, 2000, 2001, 2oo6
*
* v0.05 Removed stack-tidying code as unnecessary


        section code

        xdef MATFILL

        xref arrinfo
        xref getpars



*
MATFILL
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Fills an array with a sequence of values
*
* Note: No error checking on overflow
*
* MATFILL array%, start_value%, step%  or
*
* MATFILL array, start_value, step
*
        moveq #-1,d7            prime for arrinfo
        bsr arrinfo             get array info
        bmi.s mf_exit

        tst.w d3                get type
        blt.s err_bp            no strings for now
        beq.s mf_fp             float

        moveq #$20,d0           get two integers
        bsr getpars
        bne.s mf_exit

        move.w 0(a6,a1.l),d3    d3 = start
        move.w 2(a6,a1.l),d2    d2 = step

        move.w d3,d0

        bra.s mf_end

mfill_loop
        move.w d0,0(a6,a4.l)
        addq.l #2,a4
        add.w d2,d0

mf_end
        dbra d7,mfill_loop

mf_good
        moveq #0,d0

mf_exit
        rts
*
err_bp
        moveq #-15,d0
        rts

mf_fp

        moveq #$22,d0           get two floats
        bsr getpars
        bne.s mf_exit

        move.l 8(a6,a1.l),d4    d4.l = mant step
        beq.s mfp_0             no step is quicker

        move.w 6(a6,a1.l),d2    d2.w = exp step

        move.w 0(a6,a1.l),0(a6,a4.l)
        move.l 2(a6,a1.l),2(a6,a4.l)
        addq.l #6,a4            first element

        subq.w #1,d7
        bmi.s mfp_tidy

        move.w $11c,a2          qa.op

        bra.s mfp_end

mfp_loop
        moveq #$a,d0            qa.add
        jsr (a2)                add step to accumulated value

        move.w 0(a6,a1.l),0(a6,a4.l)
        move.l 2(a6,a1.l),2(a6,a4.l)
        addq.l #6,a4            next element

        subq.l #6,a1            new stack top
        move.w d2,0(a6,a1.l)    next step value
        move.l d4,2(a6,a1.l)

mfp_end
        dbra d7,mfp_loop

mfp_tidy
        bra.s mf_good
*
mfp_l0
        move.w 0(a6,a1.l),0(a6,a4.l)
        move.l 2(a6,a1.l),2(a6,a4.l)
        addq.l #6,a4            next element

mfp_0
        dbra d7,mfp_l0

        bra.s mf_good

*
        end
